## eztrace 2.1

=== src/eztrace-lib/CMakeLists.txt ===
add_library(eztrace-lib SHARED
  eztrace_core.c
  eztrace_otf2.c
  eztrace_internals.c
  eztrace_module.c
  include/eztrace-lib/eztrace.h
  include/eztrace-lib/eztrace_otf2.h
  include/eztrace-lib/eztrace_internals.h
  include/eztrace-lib/eztrace_module.h
  pthread_core.c
)

target_include_directories(eztrace-lib
  PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDE_DIR}>
  PRIVATE
    ${CMAKE_CURRENT_SOURCE_DIR}
)

target_compile_options(eztrace-lib
  PUBLIC
    -D_GNU_SOURCE
  PRIVATE
    -Wall -Wextra
)

target_link_libraries(eztrace-lib
  PRIVATE
    ${OTF2_LIBRARY}
    atomic
  PUBLIC
    eztrace-core
    dl
    PRIVATE
    ${CMAKE_DL_LIBS}
    rt
    m
    )

install(TARGETS eztrace-lib EXPORT EZTraceLibTargets
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/include/eztrace-lib DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

=== src/modules/CMakeLists.txt ===
# Default modules
if(EZTRACE_ENABLE_MEMORY)
  add_subdirectory(memory)
endif()
if(EZTRACE_ENABLE_POSIXIO)
  add_subdirectory(posixio)
endif()
if(EZTRACE_ENABLE_PTHREAD)
  add_subdirectory(pthread)
endif()

# Optional modules
if (EZTRACE_ENABLE_MPI)
  add_subdirectory(mpi)
endif ()

if (EZTRACE_ENABLE_OPENMP)
  add_subdirectory(omp)
endif()

if (EZTRACE_ENABLE_CUDA)
  add_subdirectory(cuda)
endif ()

if (EZTRACE_ENABLE_STARPU)
  add_subdirectory(starpu)
endif ()

if (EZTRACE_ENABLE_OMPT)
  add_subdirectory(ompt)
endif()

if(EZTRACE_ENABLE_IOTRACER)
  add_subdirectory(iotracer)
endif()

if(EZTRACE_ENABLE_PNETCDF)
  add_subdirectory(pnetcdf)
endif()

if(EZTRACE_ENABLE_NETCDF)
  add_subdirectory(netcdf)
endif()

if(EZTRACE_ENABLE_COMPILER_INSTRUMENTATION)
  add_subdirectory(compiler_instrumentation)
endif()

# Some modules have not been ported to OTF2 yet

#if (EZTRACE_ENABLE_PAPI)
#  add_subdirectory(papi)
#endif ()

=== test/memory/Makefile ===
BIN=memory vector
SHELL := /bin/bash

CFLAGS=

top_src_dir=$(PWD)/../../
cur_dir=$(PWD)

all: $(BIN)

vector: vector.cxx
	$(CXX) -o vector vector.cxx

test: all
	./run.sh

clean:
	rm -f $(BIN)

=== test/mpi/CMakeLists.txt ===
enable_testing()

if (EZTRACE_ENABLE_MPI)
  set(CMAKE_C_COMPILER ${MPICC})
  set(CMAKE_Fortran_COMPILER ${MPIF90})

  add_executable(mpi_ping ../mpi/mpi_ping.c)
  add_test (build_mpi_ping "${CMAKE_COMMAND}" --build "${CMAKE_BINARY_DIR}" --target mpi_ping)
  add_test (mpi_tests bash "${CMAKE_CURRENT_SOURCE_DIR}/../mpi/run.sh" DEPENDS build_mpi_ping)
  set(EZTRACE_LIBRARY_PATH "${EZTRACE_LIBRARY_PATH}:${CMAKE_BINARY_DIR}/src/modules/mpi")

  # Get the list of tests, and set environment variables
  get_property(test_list DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} PROPERTY TESTS)
  set_property(TEST ${test_list}
    PROPERTY ENVIRONMENT
    "EZTRACE_LIBRARY_PATH=${EZTRACE_LIBRARY_PATH}"
    ${TEST_ENVIRONMENT}
  )
endif()

=== test/mpi/Makefile ===
MPICC_PATH ?= mpicc
CC=$(MPICC_PATH)

BIN=mpi_ring mpi_multiring mpi_spawn test_mpi waitall waitany persistent mpi_ping allgather

all: $(BIN)

test: all
	./run.sh

clean:
	rm -f $(BIN)

=== test/openmp/CMakeLists.txt ===
enable_testing()

if (EZTRACE_ENABLE_OPENMP)

  # openmp tests need to be instrumented with eztrace_cc
  set(CMAKE_C_FLAGS "-fopenmp")
  set(CMAKE_C_COMPILER_LAUNCHER "${CMAKE_BINARY_DIR}/src/modules/omp/bin/eztrace_cc")

  add_executable(openmp_openmp_simple openmp_simple.c)
  add_executable(openmp_test_lock test_lock.c)
  add_executable(openmp_test_nest_lock test_nest_lock.c)
  add_executable(openmp_test_task test_task.c)

  target_link_libraries(openmp_openmp_simple eztpomp)
  target_link_libraries(openmp_test_lock eztpomp)
  target_link_libraries(openmp_test_nest_lock eztpomp)
  target_link_libraries(openmp_test_task eztpomp)

  set_target_properties(openmp_openmp_simple PROPERTIES OUTPUT_NAME "openmp_simple")
  set_target_properties(openmp_test_lock PROPERTIES OUTPUT_NAME "test_lock")
  set_target_properties(openmp_test_nest_lock PROPERTIES OUTPUT_NAME "test_nest_lock")
  set_target_properties(openmp_test_task PROPERTIES OUTPUT_NAME "test_task")

  add_test(build_openmp_simple "${CMAKE_COMMAND}" --build "${CMAKE_BINARY_DIR}" --target openmp_openmp_simple)
  add_test(build_test_lock "${CMAKE_COMMAND}" --build "${CMAKE_BINARY_DIR}" --target openmp_test_lock)
  add_test(build_test_nest_lock "${CMAKE_COMMAND}" --build "${CMAKE_BINARY_DIR}" --target openmp_test_nest_lock)
  add_test(build_test_task "${CMAKE_COMMAND}" --build "${CMAKE_BINARY_DIR}" --target openmp_test_task)

  add_test (openmp_tests bash "${CMAKE_CURRENT_SOURCE_DIR}/run.sh" DEPENDS "openmp_build_openmp_simple;openmp_build_test_lock;openmp_build_test_task")
  set(EZTRACE_LIBRARY_PATH "${EZTRACE_LIBRARY_PATH}:${CMAKE_BINARY_DIR}/src/modules/omp")


  # Get the list of tests, and set environment variables
  get_property(test_list DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} PROPERTY TESTS)
  set_property(TEST ${test_list}
    PROPERTY ENVIRONMENT
    "EZTRACE_LIBRARY_PATH=${EZTRACE_LIBRARY_PATH}"
    ${TEST_ENVIRONMENT}
  )
endif()

=== test/unit_tests/CMakeLists.txt ===
enable_testing()

add_executable(htable
  htable.c)

# depending on the framework, you need to link to it
target_link_libraries(htable
  eztrace-core)

target_compile_options(htable
  PRIVATE
    -Wall -Wextra -Wpedantic
    -Werror
)

target_include_directories(htable
  PRIVATE
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_SOURCE_DIR}/src/core/include/eztrace-core/
)

add_test(NAME htable COMMAND htable)
set(EZTRACE_LIBRARY_PATH "${CMAKE_BINARY_DIR}/src/eztrace-lib")

if (EZTRACE_ENABLE_MPI)
add_test (mpi_tests bash ${CMAKE_CURRENT_SOURCE_DIR}/../mpi/run.sh)
set(EZTRACE_LIBRARY_PATH "${EZTRACE_LIBRARY_PATH}:${CMAKE_BINARY_DIR}/src/modules/mpi")
endif()
if (EZTRACE_ENABLE_MEMORY)
add_test (memory_tests bash ${CMAKE_CURRENT_SOURCE_DIR}/../memory/run.sh)
set(EZTRACE_LIBRARY_PATH "${EZTRACE_LIBRARY_PATH}:${CMAKE_BINARY_DIR}/src/modules/memory")
endif()
if (EZTRACE_ENABLE_OPENMP)
add_test (openmp_tests bash ${CMAKE_CURRENT_SOURCE_DIR}/../openmp/run.sh)
set(EZTRACE_LIBRARY_PATH "${EZTRACE_LIBRARY_PATH}:${CMAKE_BINARY_DIR}/src/modules/omp")
endif()

if (EZTRACE_ENABLE_OMPT)
add_test (ompt_tests bash ${CMAKE_CURRENT_SOURCE_DIR}/../ompt/run.sh)
set(EZTRACE_LIBRARY_PATH "${EZTRACE_LIBRARY_PATH}:${CMAKE_BINARY_DIR}/src/modules/ompt")
endif()

if (EZTRACE_ENABLE_STARPU)
add_test (starpu_tests bash ${CMAKE_CURRENT_SOURCE_DIR}/../starpu/run.sh)
set(EZTRACE_LIBRARY_PATH "${EZTRACE_LIBRARY_PATH}:${CMAKE_BINARY_DIR}/src/modules/starpu")
endif()

# Get the list of tests, and set environment variables
get_property(test_list DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} PROPERTY TESTS)
set_property(TEST ${test_list}
  PROPERTY ENVIRONMENT
  "EZTRACE_LIBRARY_PATH=${EZTRACE_LIBRARY_PATH}"
)

=== src/modules/cuda/CMakeLists.txt ===
if(NOT DEFINED CMAKE_CUDA_ARCHITECTURES)
  set(CMAKE_CUDA_ARCHITECTURES 52 60 61 75 CACHE STRING "CUDA architectures" FORCE)
endif()
if(NOT DEFINED CMAKE_CUDA_CREATE_SHARED_LIBRARY)
  set(CMAKE_CUDA_CREATE_SHARED_LIBRARY ON)
endif()

enable_language(CXX)
#enable_language(CUDA)


find_package(CUDA REQUIRED)

#set(CUDA_SEPARABLE_COMPILATION ON)
#set(CUDA_PROPAGATE_HOST_FLAGS ON)

#link_directories(${CUDA_TOOLKIT_ROOT_DIR}/lib)
#link_directories(${CUDA_TOOLKIT_ROOT_DIR}/lib64)

add_library(eztrace-cuda SHARED)

target_sources(eztrace-cuda PRIVATE
  #  src/cuda_cupti.cpp
  cuda.c
  cuda_runtime.c
  cuda_driver.c
  )

target_link_libraries(eztrace-cuda
  eztrace-core
  eztrace-lib
  ${CUDA_LIBRARIES}
  ${CUDA_cupti_LIBRARY}
  )

target_include_directories(eztrace-cuda
  PRIVATE
  ${CUDA_INCLUDE_DIRS}
  ${CMAKE_CURRENT_SOURCE_DIR}
  ${CMAKE_SOURCE_DIR}/src/core/include/eztrace-core/
  )

#set_target_properties(eztrace-cuda PROPERTIES
#  LINKER_LANGUAGE CUDA
#  LANGUAGE CUDA
#  )

#message(STATUS "CUDA_SDK_ROOT_DIR=${CUDA_SDK_ROOT_DIR}")
#message(STATUS "CUDA_TOOLKIT_ROOT_DIR=${CUDA_TOOLKIT_ROOT_DIR}")
#message(STATUS "CUDA_LIBRARIES=${CUDA_LIBRARIES}")


#--------------------------------------------

install(TARGETS eztrace-cuda
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
  INCLUDES DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
)

=== src/modules/netcdf/CMakeLists.txt ===
set(CMAKE_C_COMPILER ${MPICC})

add_library(eztrace-netcdf SHARED
  netcdf.c
)

target_link_libraries(eztrace-netcdf
PUBLIC
    eztrace-core
    eztrace-lib
    eztrace-instrumentation
)

target_include_directories(eztrace-netcdf
  PUBLIC
    ${netcdf_INCLUDE_DIRS}
  PRIVATE
    ${CMAKE_SOURCE_DIR}/src/core/include/eztrace-core/
)

#---------------------------------------------

install(TARGETS eztrace-netcdf
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
  INCLUDES DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
)

=== src/modules/starpu/CMakeLists.txt ===
# set(CMAKE_REQUIRED_INCLUDES "${STARPU_INCLUDE_DIRS}")
# foreach(libdir ${STARPU_LIBRARY_DIRS})
#   list(APPEND CMAKE_REQUIRED_FLAGS "-L${libdir}")
# endforeach()
# string(REPLACE ";" " " CMAKE_REQUIRED_FLAGS "${CMAKE_REQUIRED_FLAGS}")
# set(CMAKE_REQUIRED_LIBRARIES "${STARPU_LIBRARIES}")

check_function_exists(starpu_mpi_data_register_comm STARPU_MPI_DATA_REGISTER_COMM_FOUND)
if ( STARPU_MPI_DATA_REGISTER_COMM_FOUND )
  add_definitions(-DHAVE_STARPU_MPI_DATA_REGISTER_COMM)
endif()


# Include directories
#include_directories(
#  ${MPI_INCLUDE_PATH}
#  )

# Libraries diretory
  # ${STARPU_LIBRARY_DIRS}

# Create : libeztrace-starpu.so
add_library(eztrace-starpu SHARED
  starpu.c
)

target_include_directories(eztrace-starpu
  PRIVATE
    ${STARPU_INCLUDE_DIRS}
)

target_link_libraries(eztrace-starpu
  PRIVATE
    dl
    eztrace-core
    eztrace-lib
    ${STARPU_LIBRARIES}
)

install(TARGETS eztrace-starpu
  LIBRARY DESTINATION lib
)

=== debian/changelog ===
eztrace (2.1-7ubuntu5) noble; urgency=medium

  * Rebuild against new clang time64_t.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 15 Apr 2024 12:54:14 +0200

eztrace (2.1-7ubuntu4) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 18:13:19 +0000

eztrace (2.1-7ubuntu3) noble; urgency=medium

  * Ignore test failures with mpich. See Debian #1066735.
  * Ignore test failures with openmpi on amd64, arm64, ppc64el.

 -- Matthias Klose <doko@debian.org>  Thu, 21 Mar 2024 23:57:15 +0100

eztrace (2.1-7) unstable; urgency=medium

  * patches/implicit: Fix build with qa=+bug-implicit-func
    (Closes: Bug#1066332)

 -- Samuel Thibault <sthibault@debian.org>  Wed, 13 Mar 2024 12:39:56 +0100

eztrace (2.1-6) unstable; urgency=medium

  * Revert adding ompt support on more archs.

 -- Samuel Thibault <sthibault@debian.org>  Sun, 15 Oct 2023 16:14:57 +0200

eztrace (2.1-5) unstable; urgency=medium

  * Add ompt support on more archs.

 -- Samuel Thibault <sthibault@debian.org>  Sun, 15 Oct 2023 15:32:16 +0200

eztrace (2.1-4) unstable; urgency=medium

  * tests/control: Drop libpapi-dev dependency, libstarpu-dev already has it
    as appropriate.

 -- Samuel Thibault <sthibault@debian.org>  Mon, 11 Sep 2023 18:34:53 +0200

eztrace (2.1-3) unstable; urgency=medium

  * tests/control: Fix starpu tests by installing gawk.

 -- Samuel Thibault <sthibault@debian.org>  Sun, 10 Sep 2023 17:35:32 +0200

eztrace (2.1-2) unstable; urgency=medium

  * control: Build-dep on starpu >= 1.4.1+dfsg-7 to get starpu job start/end
    traced.
  * patches/starpu-job: Drop patch, now that job start/end gets traced.

 -- Samuel Thibault <sthibault@debian.org>  Mon, 28 Aug 2023 12:10:28 +0200

eztrace (2.1-1) unstable; urgency=medium

  * New upstream release
    - control: Add libnetcdf-dev and libpnetcdf-dev dependencies.
    - patches/git-arm: Upstreamed.
    - patches/git-atomic: Upstreamed.
    - patches/git-eztpomp: Upstreamed.
    - patches/git-eztrace_cc_path: Upstreamed.
    - patches/git-eztrace_cc_x: Upstreamed.
    - patches/git-functions: Upstreamed.
    - patches/git-input: Upstreamed.
    - patches/git-libatomic: Upstreamed.
    - patches/git-manpage: Upstreamed.
    - patches/git-memory-noopt: Upstreamed.
    - patches/git-missing-tests: Upstreamed.
    - patches/git-mpi-init: Upstreamed.
    - patches/git-mpi-init-called: Upstreamed.
    - patches/git-mpi-types: Upstreamed.
    - patches/git-mpi_module_name: Upstreamed.
    - patches/git-no-install-cmake: Upstreamed.
    - patches/git-opari2: Upstreamed.
    - patches/git-openmp-nested-lock: Upstreamed.
    - patches/git-otf2: Upstreamed.
    - patches/git-otf2-3: Upstreamed.
    - patches/git-path_space: Upstreamed.
    - patches/git-pkg-config: Upstreamed.
    - patches/git-pkgconfig: Upstreamed.
    - patches/git-rename: Upstreamed.
    - patches/git-test-conditioned: Upstreamed.
    - patches/git-test-mpi-path: Upstreamed.
    - patches/git-test-openmp: Upstreamed.
    - patches/git-test-openmp2: Upstreamed.
    - patches/git-test-path: Upstreamed.
    - patches/git-test-paths: Upstreamed.
    - patches/git-test-preload-libs: Upstreamed.
    - patches/git-test-programs-path: Upstreamed.
    - patches/git-test-source: Upstreamed.
    - patches/git-test-verbose: Upstreamed.
    - patches/otf2-2.0.3: Upstreamed.
    - patches/starpu-1.3: Upstreamed.
    - patches/norpath: Refreshed.
    - patches/werror: Refreshed.
    - patches/git-starpu-1.4: Fix finding starpu-1.4.
    - patches/git-starpu-1.4-task_submit: Fix building against starpu 1.4.
    - patches/starpu-job: Drop some test for now.
    - patches/git-eztrace_avail: Fix finding eztrace_avail.
    - patches/git-self-link: Fix linking against libeztpomp.
    - patches/git-starpu-install: Actually install StarPU module.
    - libeztrace0.lintian-overrides: Update.
    - rules: Enable STARPU, NETCDF and PNETCDF (where applicable).
    - rules: Set STARPU_HOME to CURDIR.
    - rules: Update blhc ignore patterns.
    - tests/control: Enable compiler_instrumentation and starpu tests.

 -- Samuel Thibault <sthibault@debian.org>  Fri, 25 Aug 2023 15:03:30 +0200

eztrace (2.0+repack-12) unstable; urgency=medium

  * control: Add missing breaks+replaces between libeztrace0 and
    libeztrace-dev, missed when moving /usr/lib/*/*.so from the latter to the
    former (Closes: Bug#1034956)

 -- Samuel Thibault <sthibault@debian.org>  Thu, 27 Apr 2023 16:07:04 +0200

eztrace (2.0+repack-11) unstable; urgency=medium

  * control: Always depend on otf2, eztrace now always requires it actually.

 -- Samuel Thibault <sthibault@debian.org>  Tue, 20 Dec 2022 16:17:31 +0100

eztrace (2.0+repack-10) unstable; urgency=medium

  * control: Fix arch exclusion.

 -- Samuel Thibault <sthibault@debian.org>  Tue, 20 Dec 2022 13:25:22 +0100

eztrace (2.0+repack-9) unstable; urgency=medium

  * patches/otf2-2.0.3: Fix build with otf2 2.0.3.

 -- Samuel Thibault <sthibault@debian.org>  Tue, 20 Dec 2022 13:12:31 +0100

eztrace (2.0+repack-8) unstable; urgency=medium

  * control: Make Multi-Arch: foreign.
  * control: Drop otf2 support on archs which don't have the atomics required
    by otf2.

 -- Samuel Thibault <sthibault@debian.org>  Tue, 20 Dec 2022 12:59:58 +0100

eztrace (2.0+repack-7) unstable; urgency=medium

  * rules, tests/control: Pass --oversubscribe to openmpi to avoid failure on
    machines with only one processor.
  * rules: Make openmpi failure fatal again, now that pmix is fixed in
    unstable.
  * rules: Fix installing headers in multiarch path.

 -- Samuel Thibault <sthibault@debian.org>  Fri, 26 Aug 2022 14:11:50 +0200

eztrace (2.0+repack-6) unstable; urgency=medium

  * control: Only build-dep on clang when we'll build the ompt module.

 -- Samuel Thibault <sthibault@debian.org>  Thu, 25 Aug 2022 14:41:14 +0200

eztrace (2.0+repack-5) unstable; urgency=medium



=== debian/control ===
Source: eztrace
Section: devel
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Samuel Thibault <sthibault@debian.org>
Build-Depends: debhelper-compat (= 12),
 pkg-config,
 cmake,
 bc, gawk,
 gfortran,
 libiberty-dev, binutils-dev (>= 2.29~), zlib1g-dev,
 libotf2-trace-dev, otf2-tools,
 opari2, libpomp2-dev,
 clang [amd64 arm64 i386 ppc64el riscv64], libomp-dev [amd64 arm64 i386 ppc64el riscv64],
 libstarpu-dev (>= 1.3~), libstarpu-dev (>= 1.4.1+dfsg-7) | libstarpu-dev (<< 1.4~),
 libnetcdf-dev, libpnetcdf-dev [amd64 arm64 mips64el ppc64el s390x alpha ia64 sparc64 kfreebsd-amd64 ppc64 riscv64],
 libpapi-dev [amd64 arm64 armel armhf i386 powerpc ppc64el mips64el ppc64 x32],
 libmpich-dev, mpi-default-dev, mpi-default-bin
Rules-Requires-Root: no
Build-Conflicts: libeztrace0
Standards-Version: 4.6.0
Homepage: https://eztrace.gitlab.io/eztrace/
Vcs-Git: https://salsa.debian.org/debian/eztrace.git
Vcs-Browser: https://salsa.debian.org/debian/eztrace

Package: eztrace
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends}, ${perl:Depends}, ${misc:Depends}, libeztrace0 (= ${binary:Version}), opari2
Description: Automatic execution trace generation for HPC - tools
 EZTrace is a tool that aims at generating automatically execution traces
 from HPC (High Performance Computing) programs. It generates execution
 trace files that can be interpreted by visualization tools such as
 ViTE. It uses LD_PRELOAD and dlsym() to intercept calls to the usual HPC
 primitives, to be observed.
 .
 This package contains the tools.

Package: libeztrace-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libeztrace0 (= ${binary:Version}), ${misc:Depends}
Description: Automatic execution trace generation for HPC - development files
 EZTrace is a tool that aims at generating automatically execution traces
 from HPC (High Performance Computing) programs. It generates execution
 trace files that can be interpreted by visualization tools such as
 ViTE. It uses LD_PRELOAD and dlsym() to intercept calls to the usual HPC
 primitives, to be observed.
 .
 This package contains the development files.

Package: libeztrace0
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Breaks: libeztrace-dev (<< 2.0-1)
Replaces: libeztrace-dev (<< 2.0-1)
Pre-Depends: ${misc:Pre-Depends}
Description: Automatic execution trace generation for HPC - runtime libraries
 EZTrace is a tool that aims at generating automatically execution traces
 from HPC (High Performance Computing) programs. It generates execution
 trace files that can be interpreted by visualization tools such as
 ViTE. It uses LD_PRELOAD and dlsym() to intercept calls to the usual HPC
 primitives, to be observed.
 .
 This package contains the development files.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

include /usr/share/dpkg/architecture.mk
include /usr/share/mpi-default-dev/debian_defaults

ifeq ($(ARCH_DEFAULT_MPI_IMPL),openmpi)
OPENMPI=yes
else
OPENMPI=no
endif

OMPT_ARCHS = amd64 arm64 i386 ppc64el riscv64

CONFIGURE_ENV=
CONFIGURE=-DCMAKE_INSTALL_INCLUDEDIR=/usr/include/$(DEB_HOST_MULTIARCH)

ifeq (,$(filter $(DEB_HOST_ARCH),amd64 arm64 mips64el ppc64el s390x alpha ia64 sparc64 kfreebsd-amd64 ppc64 riscv64))
CONFIGURE+=-DEZTRACE_ENABLE_PNETCDF=OFF
endif

%:
	dh $@

override_dh_auto_configure:
	$(CONFIGURE_ENV) dh_auto_configure -Bbuild-mpich -- \
		-DEZTRACE_ENABLE_MPI=ON \
		-DEZTRACE_ENABLE_STARPU=ON \
		-DEZTRACE_ENABLE_OPENMP=ON \
		-DEZTRACE_ENABLE_POSIXIO=ON \
		-DEZTRACE_ENABLE_PTHREAD=ON \
		-DEZTRACE_ENABLE_MEMORY=ON \
		-DEZTRACE_ENABLE_OMPT=OFF \
		-DEZTRACE_ENABLE_PNETCDF=ON \
		-DEZTRACE_ENABLE_NETCDF=ON \
		-DEZTRACE_ENABLE_IOTRACER=OFF \
		$(CONFIGURE) \
		-DMPICC=/usr/bin/mpicc.mpich -DMPIF90=/usr/bin/mpif90.mpich -DMPI_MODULE_NAME=mpich
ifeq ($(OPENMPI),yes)
	$(CONFIGURE_ENV) dh_auto_configure -Bbuild-openmpi -- \
		-DEZTRACE_ENABLE_MPI=ON \
		-DEZTRACE_ENABLE_STARPU=OFF \
		-DEZTRACE_ENABLE_OPENMP=OFF \
		-DEZTRACE_ENABLE_POSIXIO=OFF \
		-DEZTRACE_ENABLE_PTHREAD=OFF \
		-DEZTRACE_ENABLE_MEMORY=OFF \
		-DEZTRACE_ENABLE_OMPT=OFF \
		-DEZTRACE_ENABLE_PNETCDF=OFF \
		-DEZTRACE_ENABLE_NETCDF=OFF \
		-DEZTRACE_ENABLE_IOTRACER=OFF \
		$(CONFIGURE) \
		-DMPICC=/usr/bin/mpicc.openmpi -DMPIF90=/usr/bin/mpif90.openmpi -DMPI_MODULE_NAME=openmpi
endif
ifneq ($(filter $(DEB_HOST_ARCH),$(OMPT_ARCHS)),)
	$(CONFIGURE_ENV) CC=clang dh_auto_configure -Bbuild-ompt -- \
		-DEZTRACE_ENABLE_MPI=OFF \
		-DEZTRACE_ENABLE_STARPU=OFF \
		-DEZTRACE_ENABLE_OPENMP=OFF \
		-DEZTRACE_ENABLE_POSIXIO=OFF \
		-DEZTRACE_ENABLE_PTHREAD=OFF \
		-DEZTRACE_ENABLE_MEMORY=OFF \
		-DEZTRACE_ENABLE_OMPT=ON \
		-DEZTRACE_ENABLE_PNETCDF=OFF \
		-DEZTRACE_ENABLE_NETCDF=OFF \
		-DEZTRACE_ENABLE_IOTRACER=OFF \
		$(CONFIGURE)
endif

override_dh_auto_build:
	@echo 'blhc: ignore-line-regexp: \[\ *[0-9]+%\]\ Building\ C\ object\ (src|test)/.+\.c\.o'
	dh_auto_build -Bbuild-mpich
ifeq ($(OPENMPI),yes)
	dh_auto_build -Bbuild-openmpi
endif
ifneq ($(filter $(DEB_HOST_ARCH),$(OMPT_ARCHS)),)
	dh_auto_build -Bbuild-ompt
endif

override_dh_auto_clean:
	dh_auto_clean -Bbuild-mpich
ifeq ($(OPENMPI),yes)
	dh_auto_clean -Bbuild-openmpi
endif
ifneq ($(filter $(DEB_HOST_ARCH),$(OMPT_ARCHS)),)
	dh_auto_clean -Bbuild-ompt
endif

override_dh_auto_install:
	dh_auto_install -Bbuild-mpich
ifeq ($(OPENMPI),yes)
	dh_auto_install -Bbuild-openmpi -- -C src/modules/mpi
endif
ifneq ($(filter $(DEB_HOST_ARCH),$(OMPT_ARCHS)),)
	dh_auto_install -Bbuild-ompt -- -C src/modules/ompt
endif

# Some MPI drivers assume we won't fork, but we will, so tell them to be safe.
export RDMAV_FORK_SAFE=1

override_dh_auto_test:
	@echo 'blhc: ignore-line-regexp: ([0-9]*:\ )?.*src/modules/omp/bin/eztrace_cc\ .*'
	@echo 'blhc: ignore-line-regexp: ([0-9]*:\ )?\[eztrace_cc\].*'
	@echo 'blhc: ignore-line-regexp: ([0-9]*:\ )?cc\ -o\ test_task.*'
	@echo 'blhc: ignore-line-regexp: ([0-9]*:\ )?cc\ -o\ starpu_.*'
	@echo 'blhc: ignore-line-regexp: ([0-9]*:\ )?cc\ -o\ .*\ -pthread'
	@echo 'blhc: ignore-line-regexp: ([0-9]*:\ )?cc.*\ memory.c.*\ -o\ memory'
	@echo 'blhc: ignore-line-regexp: ([0-9]*:\ )?cc\ -o\ foo\ foo.c.*'
	@echo 'blhc: ignore-line-regexp: ([0-9]*:\ )?g\+\+\ -o\ vector\ vector.cxx'
	@echo 'blhc: ignore-line-regexp: ([0-9]*:\ )?.*/cc\ .*\ -c\ .*/test/.*.c'
	-verbose=1 STARPU_HOME=$(CURDIR) MPICC_PATH=mpicc.mpich MPIRUN_PATH=mpirun.mpich MPI_MODULE_NAME=mpich dh_auto_test --no-parallel -Bbuild-mpich -- -k ARGS\+=--extra-verbose
	-rm -fr .starpu
ifeq ($(OPENMPI),yes)
ifneq (,$(filter $(DEB_HOST_ARCH),amd64 arm64 ppc64el))
	-verbose=1 MPIRUN_CLI_OPTION=--oversubscribe MPICC_PATH=mpicc.openmpi MPIRUN_PATH=mpirun.openmpi MPI_MODULE_NAME=openmpi dh_auto_test --no-parallel -Bbuild-openmpi -- -k ARGS\+=--extra-verbose
else
	verbose=1 MPIRUN_CLI_OPTION=--oversubscribe MPICC_PATH=mpicc.openmpi MPIRUN_PATH=mpirun.openmpi MPI_MODULE_NAME=openmpi dh_auto_test --no-parallel -Bbuild-openmpi -- -k ARGS\+=--extra-verbose
endif
endif
ifneq ($(filter $(DEB_HOST_ARCH),$(OMPT_ARCHS)),)
	verbose=1 dh_auto_test --no-parallel -Bbuild-ompt -- -k ARGS\+=--extra-verbose
endif

override_dh_dwz:
	:

=== debian/tests/control ===
Depends: build-essential, eztrace, otf2-tools
Test-Command: cd test/compiler_instrumentation ; make clean ; verbose=1 ./run.sh
Restrictions: allow-stderr

Depends: build-essential, eztrace, otf2-tools, gawk
Test-Command: cd test/memory ; make clean ; verbose=1 ./run.sh
Restrictions: allow-stderr

Depends: build-essential, eztrace, otf2-tools, mpich, libmpich-dev, gawk
Test-Command: cd test/mpi ; make clean ; MPICC_PATH=mpicc.mpich MPIRUN_PATH=mpirun.mpich MPI_MODULE_NAME=mpich verbose=1 ./run.sh
Restrictions: allow-stderr

Depends: build-essential, eztrace, otf2-tools, openmpi-bin, libopenmpi-dev, gawk
Test-Command: cd test/mpi ; make clean ; MPIRUN_CLI_OPTION=--oversubscribe MPICC_PATH=mpicc.openmpi MPIRUN_PATH=mpirun.openmpi MPI_MODULE_NAME=openmpi verbose=1 ./run.sh
Restrictions: skip-not-installable, allow-stderr

Depends: build-essential, eztrace, otf2-tools, clang, libomp-dev, gawk
Test-Command: cd test/ompt ; make clean ; verbose=1 ./run.sh
Architecture: amd64 arm64 i386 ppc64el riscv64
Restrictions: allow-stderr

Depends: build-essential, eztrace, otf2-tools, libpomp2-dev, bc, gawk
Test-Command: cd test/openmp ; make clean ; verbose=1 ./run.sh
Restrictions: allow-stderr

Depends: build-essential, eztrace, otf2-tools, bc
Test-Command: cd test/posixio ; make clean ; verbose=1 ./run.sh
Restrictions: allow-stderr

Depends: build-essential, eztrace, otf2-tools
Test-Command: cd test/pthread ; make clean ; verbose=1 ./run.sh
Restrictions: allow-stderr

Depends: build-essential, eztrace, otf2-tools, pkg-config, libstarpu-dev, gawk
Test-Command: cd test/starpu ; make clean ; verbose=1 ./run.sh
Restrictions: allow-stderr

## eztrace 2.1.1

=== test/CMakeLists.txt ===
enable_testing()

set(EZTRACE_LIBRARY_PATH "${CMAKE_BINARY_DIR}/src/eztrace-lib")
set(TEST_ENVIRONMENT  "EZTRACE_AVAIL_PATH=${CMAKE_BINARY_DIR}/src/eztrace_avail"
  "EZTRACE_CC_PATH=${CMAKE_BINARY_DIR}/src/modules/omp/bin/eztrace_cc"
  "LIBRARY_PATH=$ENV{LIBRARY_PATH}:${CMAKE_BINARY_DIR}/src/modules/omp"
  "LD_LIBRARY_PATH=$ENV{LD_LIBRARY_PATH}:${CMAKE_BINARY_DIR}/src/modules/omp"
  "EZTRACE_PATH=${CMAKE_BINARY_DIR}/src/eztrace"
  "OTF2_PRINT_PATH=${OTF2_PRINT}"
  "EZTRACE_TEST_OPTION=-p"
)


add_subdirectory (unit_tests)

if (EZTRACE_ENABLE_COMPILER_INSTRUMENTATION)
  add_subdirectory (compiler_instrumentation)
endif()

if (EZTRACE_ENABLE_MPI)
  add_subdirectory (mpi)
endif()

if (EZTRACE_ENABLE_MEMORY)
  add_subdirectory (memory)
endif()

if (EZTRACE_ENABLE_OPENMP)
  add_subdirectory (openmp)
endif()

if (EZTRACE_ENABLE_OMPT)
  add_subdirectory (ompt)
endif()

if (EZTRACE_ENABLE_PTHREAD)
  add_subdirectory (pthread)
endif()

if (EZTRACE_ENABLE_POSIXIO)
  add_subdirectory (posixio)
endif()

=== src/modules/CMakeLists.txt ===
--- 
+++ 
@@ -24,6 +24,9 @@
 
 if (EZTRACE_ENABLE_STARPU)
   add_subdirectory(starpu)
+endif()
+if (EZTRACE_ENABLE_STARPU_API)
+  add_subdirectory(starpu_api)
 endif ()
 
 if (EZTRACE_ENABLE_OMPT)

=== src/plugin_creator/CMakeLists.txt ===
set (INSTALL_INPUTDIR ${CMAKE_INSTALL_FULL_DATADIR})
set (INSTALL_BINDIR ${CMAKE_INSTALL_FULL_BINDIR})

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/eztrace_create_plugin.in 
  ${CMAKE_CURRENT_BINARY_DIR}/eztrace_create_plugin
  @ONLY)


list(APPEND SCRIPTS
  ${CMAKE_CURRENT_BINARY_DIR}/eztrace_create_plugin
  )


install(PROGRAMS ${SCRIPTS} DESTINATION ${CMAKE_INSTALL_BINDIR})
install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/eztrace DESTINATION ${CMAKE_INSTALL_DATADIR})

=== test/compiler_instrumentation/CMakeLists.txt ===
enable_testing()

if (EZTRACE_ENABLE_COMPILER_INSTRUMENTATION)

  set(CMAKE_C_FLAGS "-finstrument-functions -O0")
  set(LINK_OPTIONS  "-rdynamic")

  add_executable(foo foo.c)
  add_test(build_foo "${CMAKE_COMMAND}" --build "${CMAKE_BINARY_DIR}" --target foo)

  add_test (compiler_instrumentation_tests bash "${CMAKE_CURRENT_SOURCE_DIR}/run.sh" DEPENDS "build_foo_cat")
  set(EZTRACE_LIBRARY_PATH "${EZTRACE_LIBRARY_PATH}:${CMAKE_BINARY_DIR}/src/modules/compiler_instrumentation")


  # Get the list of tests, and set environment variables
  get_property(test_list DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} PROPERTY TESTS)
  set_property(TEST ${test_list}
    PROPERTY ENVIRONMENT
    "EZTRACE_LIBRARY_PATH=${EZTRACE_LIBRARY_PATH}"
    ${TEST_ENVIRONMENT}
  )
endif()

=== test/memory/CMakeLists.txt ===
enable_testing()

if (EZTRACE_ENABLE_MEMORY)

  set(CMAKE_C_FLAGS "-pthread")
  set(LINK_OPTIONS  "-pthread")

  add_executable(memory memory.c)
  add_test (build_memory "${CMAKE_COMMAND}" --build "${CMAKE_BINARY_DIR}" --target memory)
  add_test (memory_tests bash "${CMAKE_CURRENT_SOURCE_DIR}/run.sh" DEPENDS build_memory)
  set(EZTRACE_LIBRARY_PATH "${EZTRACE_LIBRARY_PATH}:${CMAKE_BINARY_DIR}/src/modules/memory")


  # Get the list of tests, and set environment variables
  get_property(test_list DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} PROPERTY TESTS)
  set_property(TEST ${test_list}
    PROPERTY ENVIRONMENT
    "EZTRACE_LIBRARY_PATH=${EZTRACE_LIBRARY_PATH}"
    ${TEST_ENVIRONMENT}
  )
endif()

=== test/openmp/Makefile ===
EZTRACE_CC_PATH ?= eztrace_cc
CC=$(EZTRACE_CC_PATH) cc
CXX=$(EZTRACE_CC_PATH) g++
CFLAGS=-fopenmp
LDFLAGS=-fopenmp -lm

BIN=openmp_nowait_c openmp_simple openmp_cpp parallel test_lock test_nest_lock test_task

all: $(BIN)

%: %.c
	$(CC) -o $@ $^ $(CFLAGS) $(LDFLAGS)
%: %.cpp
	$(CXX) -o $@ $^ $(CFLAGS) $(LDFLAGS)

test: $(BIN)
	./run.sh
clean:
	rm -f $(BIN)

=== test/pthread/Makefile ===
CFLAGS=
LDFLAGS=-pthread

BIN=cond  dummy_thread  race_cond  test_pthread  test_sigsegv

all: $(BIN)

%: %.c
	$(CC) -o $@ $^ $(CFLAGS) $(LDFLAGS)

test: $(BIN)
	./run.sh
clean:
	rm -f $(BIN)

=== test/static/Makefile ===
CC=cc
BIN=static libeztrace-staticlib.so

all: $(BIN)

libeztrace-staticlib.so: staticlib.c
	$(CC) -fPIC -shared -o libeztrace-staticlib.so staticlib.c $(CFLAGS) $(LDFLAGS)

test: all
	./run.sh

clean:
	rm -f $(BIN)

=== test/unit_tests/CMakeLists.txt ===
--- 
+++ 
@@ -50,5 +50,6 @@
 set_property(TEST ${test_list}
   PROPERTY ENVIRONMENT
   "EZTRACE_LIBRARY_PATH=${EZTRACE_LIBRARY_PATH}"
+  ${TEST_ENVIRONMENT}
 )

=== src/modules/compiler_instrumentation/CMakeLists.txt ===
set(CMAKE_C_COMPILER ${MPICC})

add_library(eztrace-compiler_instrumentation SHARED
  compiler_instrumentation.c
)

target_link_libraries(eztrace-compiler_instrumentation
PUBLIC
    eztrace-core
    eztrace-lib
    eztrace-instrumentation
)

target_include_directories(eztrace-compiler_instrumentation
  PUBLIC
    ${compiler_instrumentation_INCLUDE_DIRS}
  PRIVATE
    ${CMAKE_SOURCE_DIR}/src/core/include/eztrace-core/
)

#---------------------------------------------

install(TARGETS eztrace-compiler_instrumentation
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
  INCLUDES DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
)

=== src/modules/cuda/CMakeLists.txt ===
--- 
+++ 
@@ -20,7 +20,6 @@
 add_library(eztrace-cuda SHARED)
 
 target_sources(eztrace-cuda PRIVATE
-  #  src/cuda_cupti.cpp
   cuda.c
   cuda_runtime.c
   cuda_driver.c
@@ -38,6 +37,7 @@
   ${CUDA_INCLUDE_DIRS}
   ${CMAKE_CURRENT_SOURCE_DIR}
   ${CMAKE_SOURCE_DIR}/src/core/include/eztrace-core/
+  ${CUDAToolkit_CUPTI_INCLUDE_DIR}
   )
 
 #set_target_properties(eztrace-cuda PROPERTIES

=== src/modules/iotracer/CMakeLists.txt ===
add_library(eztrace-iotracer SHARED
  iotracer.c
  iotracer_to_otf2.c
)

target_link_libraries(eztrace-iotracer
  PRIVATE
    atomic
    dl
    eztrace-core
    eztrace-lib
    eztrace-instrumentation
)

target_include_directories(eztrace-iotracer
  PRIVATE
  ${CMAKE_SOURCE_DIR}/src/core/include/eztrace-core/
)

#---------------------------------------------

install(TARGETS eztrace-iotracer
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
  INCLUDES DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
)

=== debian/changelog ===
eztrace (2.1.1-5ubuntu1) plucky; urgency=medium

  * Merge with Debian unstable. Remaining changes:
    - Ignore test failures with mpich. See Debian #1066735.
    - Ignore test failures with openmpi on amd64, arm64, ppc64el.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Fri, 17 Jan 2025 20:41:16 +0000

eztrace (2.1.1-5) unstable; urgency=medium

  * watch: Use api to get tags.
    - Add more runpath lintian override.
  * control, rules: Enable ompt on riscv64 and loong64.

 -- Samuel Thibault <sthibault@debian.org>  Sat, 11 Jan 2025 02:28:03 +0100

eztrace (2.1.1-4ubuntu1) plucky; urgency=medium

  * Merge back old delta lost during sync. Remaining changes:
    - Ignore test failures with mpich. See Debian #1066735.
    - Ignore test failures with openmpi on amd64, arm64, ppc64el.
  * New changes:
    - Ignore failure of new tests.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Fri, 06 Dec 2024 10:15:48 +0000

eztrace (2.1.1-4build1) plucky; urgency=medium

  * No-change rebuild for libopenmpi40

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Thu, 05 Dec 2024 11:57:58 +0000

eztrace (2.1.1-4) unstable; urgency=medium

  * tests/control: Also disable ompt tests on i386 and riscv64.

 -- Samuel Thibault <sthibault@debian.org>  Sun, 10 Nov 2024 19:41:06 +0100

eztrace (2.1.1-3) unstable; urgency=medium

  * control, rules: Disable ompt on armhf.

 -- Samuel Thibault <sthibault@debian.org>  Sun, 10 Nov 2024 10:30:33 +0100

eztrace (2.1.1-2) unstable; urgency=medium

  * control, rules: Disable ompt on i386 and riscv64, enable it on armhf.
  * rules: Avoid confusion between mpich and openmpi builds.
  * rules: Disable binding on the smoke test.

 -- Samuel Thibault <sthibault@debian.org>  Sun, 10 Nov 2024 03:14:44 +0100

eztrace (2.1.1-1) unstable; urgency=medium

  * New upstream release.
    - debian/patches/git-self-link: Upstreamed.
    - debian/patches/git-starpu-1.4: Upstreamed.
    - debian/patches/git-starpu-1.4-task_submit: Upstreamed.
    - debian/patches/git-eztrace_avail: Upstreamed.
    - debian/patches/git-starpu-install: Upstreamed.
    - debian/patches/implicit: Upstreamed.
  * debian/rules: Run all testsuites before reporting the failures
    (Closes: Bug#1067468)
  * debian/rules: Add mpi smoketest rules.
  * debian/control: Depend on pkgconf instead of pkg-config.

 -- Samuel Thibault <sthibault@debian.org>  Sun, 10 Nov 2024 02:21:32 +0100

eztrace (2.1-7ubuntu6) oracular; urgency=medium

  * No-change rebuild against mpi-defaults 1.17

 -- Erich Eickmeyer <eeickmeyer@ubuntu.com>  Wed, 31 Jul 2024 10:47:10 -0700

=== debian/control ===
--- 
+++ 
@@ -4,14 +4,14 @@
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 XSBC-Original-Maintainer: Samuel Thibault <sthibault@debian.org>
 Build-Depends: debhelper-compat (= 12),
- pkg-config,
+ pkgconf,
  cmake,
  bc, gawk,
  gfortran,
  libiberty-dev, binutils-dev (>= 2.29~), zlib1g-dev,
  libotf2-trace-dev, otf2-tools,
  opari2, libpomp2-dev,
- clang [amd64 arm64 i386 ppc64el riscv64], libomp-dev [amd64 arm64 i386 ppc64el riscv64],
+ clang [amd64 arm64 ppc64el riscv64 loong64], libomp-dev [amd64 arm64 ppc64el riscv64 loong64],
  libstarpu-dev (>= 1.3~), libstarpu-dev (>= 1.4.1+dfsg-7) | libstarpu-dev (<< 1.4~),
  libnetcdf-dev, libpnetcdf-dev [amd64 arm64 mips64el ppc64el s390x alpha ia64 sparc64 kfreebsd-amd64 ppc64 riscv64],
  libpapi-dev [amd64 arm64 armel armhf i386 powerpc ppc64el mips64el ppc64 x32],

=== debian/rules ===
--- 
+++ 
@@ -5,13 +5,15 @@
 include /usr/share/dpkg/architecture.mk
 include /usr/share/mpi-default-dev/debian_defaults
 
+FAILED=debian/failed
+
 ifeq ($(ARCH_DEFAULT_MPI_IMPL),openmpi)
 OPENMPI=yes
 else
 OPENMPI=no
 endif
 
-OMPT_ARCHS = amd64 arm64 i386 ppc64el riscv64
+OMPT_ARCHS = amd64 arm64 ppc64el riscv64 loong64
 
 CONFIGURE_ENV=
 CONFIGURE=-DCMAKE_INSTALL_INCLUDEDIR=/usr/include/$(DEB_HOST_MULTIARCH)
@@ -108,17 +110,21 @@
 	@echo 'blhc: ignore-line-regexp: ([0-9]*:\ )?cc\ -o\ foo\ foo.c.*'
 	@echo 'blhc: ignore-line-regexp: ([0-9]*:\ )?g\+\+\ -o\ vector\ vector.cxx'
 	@echo 'blhc: ignore-line-regexp: ([0-9]*:\ )?.*/cc\ .*\ -c\ .*/test/.*.c'
-	-verbose=1 STARPU_HOME=$(CURDIR) MPICC_PATH=mpicc.mpich MPIRUN_PATH=mpirun.mpich MPI_MODULE_NAME=mpich dh_auto_test --no-parallel -Bbuild-mpich -- -k ARGS\+=--extra-verbose
+	-mpirun.mpich -np 2 --bind-to none ./build-mpich/test/mpi/mpi_ping | grep "10000	16" || touch $(FAILED)
+	make -C test/mpi clean
+	-verbose=1 STARPU_HOME=$(CURDIR) MPICC_PATH=mpicc.mpich MPIRUN_PATH=mpirun.mpich MPI_MODULE_NAME=mpich dh_auto_test --no-parallel -Bbuild-mpich -- -k ARGS\+=--extra-verbose || touch $(FAILED)
 	-rm -fr .starpu
 ifeq ($(OPENMPI),yes)
+	-mpirun.openmpi -np 2 --map-by :OVERSUBSCRIBE --bind-to none ./build-openmpi/test/mpi/mpi_ping | grep "10000	16" || touch $(FAILED)
+	make -C test/mpi clean
 ifneq (,$(filter $(DEB_HOST_ARCH),amd64 arm64 ppc64el))
-	-verbose=1 MPIRUN_CLI_OPTION=--oversubscribe MPICC_PATH=mpicc.openmpi MPIRUN_PATH=mpirun.openmpi MPI_MODULE_NAME=openmpi dh_auto_test --no-parallel -Bbuild-openmpi -- -k ARGS\+=--extra-verbose
+	-verbose=1 MPIRUN_CLI_OPTION=--oversubscribe MPICC_PATH=mpicc.openmpi MPIRUN_PATH=mpirun.openmpi MPI_MODULE_NAME=openmpi dh_auto_test --no-parallel -Bbuild-openmpi -- -k ARGS\+=--extra-verbose || touch $(FAILED)
 else
-	verbose=1 MPIRUN_CLI_OPTION=--oversubscribe MPICC_PATH=mpicc.openmpi MPIRUN_PATH=mpirun.openmpi MPI_MODULE_NAME=openmpi dh_auto_test --no-parallel -Bbuild-openmpi -- -k ARGS\+=--extra-verbose
+	verbose=1 MPIRUN_CLI_OPTION=--oversubscribe MPICC_PATH=mpicc.openmpi MPIRUN_PATH=mpirun.openmpi MPI_MODULE_NAME=openmpi dh_auto_test --no-parallel -Bbuild-openmpi -- -k ARGS\+=--extra-verbose || touch $(FAILED)
 endif
 endif
 ifneq ($(filter $(DEB_HOST_ARCH),$(OMPT_ARCHS)),)
-	verbose=1 dh_auto_test --no-parallel -Bbuild-ompt -- -k ARGS\+=--extra-verbose
+	-verbose=1 dh_auto_test --no-parallel -Bbuild-ompt -- -k ARGS\+=--extra-verbose || touch $(FAILED)
 endif
 
 override_dh_dwz:

=== debian/tests/control ===
--- 
+++ 
@@ -16,7 +16,7 @@
 
 Depends: build-essential, eztrace, otf2-tools, clang, libomp-dev, gawk
 Test-Command: cd test/ompt ; make clean ; verbose=1 ./run.sh
-Architecture: amd64 arm64 i386 ppc64el riscv64
+Architecture: amd64 arm64 ppc64el riscv64 loong64
 Restrictions: allow-stderr
 
 Depends: build-essential, eztrace, otf2-tools, libpomp2-dev, bc, gawk
